import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Actor
{
    public int health = 3;
    int num = 0;
    boolean is_right = true;
    boolean is_anim = false;
    boolean play = true;
    int speed = 5;
    int count = 2;
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Player()
    {

    }

    public void act() 
    {
        Check_Key();
        Check_Remove();
    }

    void Check_Remove()
    {
        
        Actor hook = getOneIntersectingObject(Hook.class);
        if(hook != null)
        {
            if(inters(getX()-getImage().getWidth()/2, getY()-getImage().getHeight()/2, getX() + getImage().getWidth()/2, getY() + getImage().getHeight()/2, hook.getX()-13, hook.getY()-48, hook.getX()+13, hook.getY()) == true)
            {
                Hook hk = (Hook)hook;
                
                //MyWorld mw = (MyWorld)getWorld();
                //mw.count -= 1;
                if(is_anim == false && hk.is_up == false)
                {
                    hk.Set_is_up(true);
                    is_anim = true;
                    Heart_Attack h_a = new Heart_Attack(this);            
                    getWorld().addObject(h_a, getX(), getY());
                    Change_Health();
                }
                //getWorld().removeObject(hook);
                //System.out.println(hook.getX()-36);
                //System.out.println(hook.getY()-48);
                //System.out.println("x = " + getX() + ", y = "+ getY());
            }
        }
        Actor eat = getOneIntersectingObject(Food.class);
        if(eat != null)
            {
                MyWorld mw = (MyWorld)getWorld();
                mw.score += 1;
                mw.removeObject(eat);
                mw.str.Set_Text(String.valueOf(mw.score));
                
            }
    }
    
    void Change_Health()
    {
        
        MyWorld mw = (MyWorld)getWorld();
        mw.array_heart[health-1].SetIs();
        health -= 1;
        
        if(health == 0)
        {
           play = false;
           mw.New();
           //getWorld().removeObject(this);
        }
    }
    
    boolean inters(int a_x, int a_y, int a_x_1, int a_y_1, int b_x, int b_y, int b_x_1, int b_y_1)
    {
        if(a_x < b_x_1 && a_x_1 > b_x && a_y < b_y_1 && a_y_1 > b_y)
        {
            return true;
        }
        return false;
    }

    
    public void Check_Key()
    {
        if(play==true)
        {
            if(Greenfoot.isKeyDown("right")) { Move_Right(); }
            if(Greenfoot.isKeyDown("left")) { Move_Left(); }
            if(Greenfoot.isKeyDown("up")) { Move_Up(); }
            if(Greenfoot.isKeyDown("down")) { Move_Down(); }
        }
    }

    void Move_Right() {
        if(getX() < (getWorld().getWidth() - (getImage().getWidth()/2))) {
            if(is_right == false) {
                is_right = true;
                getImage().mirrorHorizontally();
            }
            setLocation(getX() + speed, getY());
            Anim();
        }       
    }

    void Move_Left() {
        if(getX() > (0 + (getImage().getWidth()/2))) {
            if(is_right == true) {
                is_right = false;
                getImage().mirrorHorizontally();
            }
            setLocation(getX() - speed, getY());
            Anim();
        }       
    }

    void Move_Up() {
        if(getY() > (0 + (getImage().getHeight()/2))) {
            setLocation(getX(), getY() - speed);
        }   
    }

    void Move_Down() {
        if(getY() < (getWorld().getHeight() - (getImage().getHeight()/2))) {
            setLocation(getX(), getY() + speed);
        }  
    }
    void Anim()
    {
        num++;
        if(num%5 == 0)
        {
            if(count == 1)
            {
                setImage("fish_01.png");                
            }

            if(count == 2)
            {
                setImage("fish_02.png");
                count = 0;
            }
            if(!is_right)
            {
                getImage().mirrorHorizontally();
            }
            count++;
            
            
        }
    }

}
