import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class MyWorld here.
 * 
 * @author (BogdanKireev)
 * @author (YuliaKhrishtopova)
 * @author (MariaBavarova)
 * @version (1)
 */
public class MyWorld extends World
{
    int num = 0;
    int count = 0;
    int[] x_coordinates = new int[] {40, 100, 160, 220, 280, 340, 400, 460, 500, 560 };
    public int score = 0;
    int best_score = 0;
    public Text str, str2;
    Heart[] array_heart = new Heart[3];
    boolean end = false;
    boolean play = true;
    
    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 400, 1);
        
        addObject(new HUD(), getWidth()-60, 45);
        str = new Text("0");
        addObject(str, getWidth()-59, 73);
        
        
        for(int i = 0; i < 3; i++)
        {
            array_heart[i] = new Heart();
            addObject(array_heart[i], 40 + i * 30, getHeight()-30);
        }
        
        addObject(new Player(), 64, 200);
        Random_Array();
        
        //addObject(new Text(String.valueOf(score)), getWidth()/2, getHeight()/2);
    }
    
    public void New()
    {
        end = true;
        play= false;
        num = 0;
    }
    
    void Show()
    {
        if(end)
        {
            addObject(new Score_Panel(), getWidth()/2, getHeight()/2);
            addObject(new Text(String.valueOf(score)), getWidth()/2, getHeight()/2);
            end = false;
        }
                if(num%300 == 0)
            {
                Greenfoot.setWorld(new MyWorld());
            }
    }
    
    public void act()
    {
        num++;
        if(play == true)
            Spawn();
            
        if(play == false)    
        Show();
        
    }
    
    void Spawn()
    {
        if(num%50 == 0)
        {
            addObject(new Food(), Greenfoot.getRandomNumber(getWidth()), 0);
        }
        if(count < 10)
        {
            if(num%200 == 0)
            {
                addObject(new Hook(Greenfoot.getRandomNumber(getHeight()-48)+48, 2), x_coordinates[Greenfoot.getRandomNumber(10)], 0);
                count++;
                num=0;
            }
        }
      
    }
    
    void Random_Array()
    {
        int[] temp = new int[10];
        for(int i = 0; i < 10; i++)
        {
            int t = x_coordinates[i];
            int r = Greenfoot.getRandomNumber(10);
            x_coordinates[i] = x_coordinates[r];
            x_coordinates[r] = t;
        }
    }

}
